#include <DCC_Decoder.h>

#define kDCC_INTERRUPT 0

int start_addr = 0;
int end_addr = 31;  // end_addr <= start_addr + 31
int old_addr = 512;
byte old_data = 0;
byte addr_data = 0;

void BasicAccDecoderPacket_Handler(int address, boolean activate, byte data)
{
    if( address >= start_addr && address <= end_addr )
    {
        if( address != old_addr || data != old_data )  //если не повтор команды
        {
            old_addr = address;
            old_data = data;
            addr_data = (address - start_addr) * 8 + data;          
            Serial.write(addr_data);
            digitalWrite(11, 1);  //контроль адресов из диапазона
            digitalWrite(10, 0);
            //Serial.println(addr_data,BIN);
        } else
        {
            digitalWrite(11, 0);
        }
    } else 
    {
        digitalWrite(10, 1);  //контроль адресов кроме диапазона
    }
}

void setup() 
{ 
    Serial.begin(115200);
    pinMode(11, OUTPUT);  //контроль адресов из диапазона
    digitalWrite(11, 0);
    pinMode(10, OUTPUT);  //контроль адресов кроме диапазона
    digitalWrite(10, 0);
   
    DCC.SetBasicAccessoryDecoderPacketHandler(BasicAccDecoderPacket_Handler, true);
    DCC.SetupDecoder( 0x00, 0x00, kDCC_INTERRUPT );
}

void loop()
{
    DCC.loop();  // Loop DCC library
}

