#include <EEPROM.h>
#include <Wire.h>  //библиотека обмена по I2C
#include <LiquidCrystal_I2C.h>  //библиотека экрана
#include <Adafruit_PWMServoDriver.h>  //библиотека драйвера РСА9685

#define SERVOMIN  180 // this is the 'minimum' pulse length count (out of 4096)
#define SERVOMAX  435 // this is the 'maximum' pulse length count (out of 4096)

Adafruit_PWMServoDriver pwm40 = Adafruit_PWMServoDriver(0x40);  //объявляем драйвер - адрес 0х40
Adafruit_PWMServoDriver pwm41 = Adafruit_PWMServoDriver(0x40);  //объявляем драйвер - адрес 0х41
Adafruit_PWMServoDriver pwm42 = Adafruit_PWMServoDriver(0x40);  //объявляем драйвер - адрес 0х42
Adafruit_PWMServoDriver pwm43 = Adafruit_PWMServoDriver(0x40);  //объявляем драйвер - адрес 0х43
Adafruit_PWMServoDriver pwm44 = Adafruit_PWMServoDriver(0x40);  //объявляем драйвер - адрес 0х44
Adafruit_PWMServoDriver pwm45 = Adafruit_PWMServoDriver(0x40);  //объявляем драйвер - адрес 0х45
Adafruit_PWMServoDriver pwm46 = Adafruit_PWMServoDriver(0x40);  //объявляем драйвер - адрес 0х46
Adafruit_PWMServoDriver pwm47 = Adafruit_PWMServoDriver(0x40);  //объявляем драйвер - адрес 0х47

volatile byte addrStart = 0;  //с какого реального адреса начинается

LiquidCrystal_I2C lcd(0x27, 16, 2);  //Устанавливаем дисплей, бывали контроллеры с адресами 0x3F 0x27

uint8_t newChar0[8] = {  //спец.символ стрелка вбок
  B00001, B10001, B01001, B00100, B00010, B00001, B00001, B00000
};

uint8_t newChar1[8] = {  //спец.символ стрелка прямо
  B00001, B10001, B01001, B00101, B00101, B00001, B00001, B00000
}; 

volatile byte angleMin[128];  // угол установки для положения 0 (вбок) 0..255  EEPROM
volatile byte angleMax[128];  // угол установки для положения 1 (прямо) 0..255  EEPROM
volatile byte angleNow[128];  // текущий угол сервы
volatile byte srvSpeed[128];  // скорость поворота - приращение угла за 1 такт таймера  EEPROM
volatile byte srvSetup[128];  // boolean - битовые переменные  EEPROM:
                              // bit 7 - реверс команд
                              // bit 6 - детач??
                              // bit 5 - 
                              // bit 4 - 
                              // bit 3 - 
                              // bit 2 - 
                              // bit 1 - 
                              // bit 0 - 
volatile byte srvBool[128];   // boolean - текущие битовые переменные:
                              // bit 7 - 
                              // bit 6 - 
                              // bit 5 - 
                              // bit 4 - 
                              // bit 3 - текущее положение: 0 вбок, 1 прямо
                              // bit 2 - последняя команда: 0 вбок, 1 прямо
                              // bit 1 - в работе
                              // bit 0 - 
                              
unsigned long onMilli = 0;  //хранение времени предыдущего тика таймера

volatile int encVal = 0;  //текущее значение переменной "энкодер"
volatile int encMax = 10;  //максимальное значение переменной "энкодер"
volatile int encMin = -10;  //минимальное значение переменной "энкодер"
volatile byte addrOld = 0;  //предыдущий адрес (для меню)
volatile byte srvSpdOld = 0;  //предыдущая скорость (для меню)

volatile bool inLCD = 0;  //флаг наличия дисплея и энкодера
volatile bool inNext = 0;  //флаг "переход к следующему адресу"
volatile byte menuNum = 0;  //номер пункта меню: 
                            //1 - выбор адреса
                            //2 - изменение минимального угла
                            //3 - изменение максимального угла
                            //4 - изменение скорости
                            //5 - изменение реверса
                            //6 - выбор дальнейших действий
                            //7 - MORE дополнительные настройки
                            //8 - NEXT переход к настройке следующего адреса
                            //9 - EXIT выход из настройки
                            //10 - SAVE сохранение изменений в EEPROM

volatile byte _tmp = 0;

//=========================================================================================

void ConfigurePCA9685()  //конфигурирование драйверов РСА
{
    pwm40.begin();
    pwm40.setPWMFreq(50);  //частота ШИМ: 50Гц для серв, повыше для света
    pwm41.begin();
    pwm41.setPWMFreq(50);
    pwm42.begin();
    pwm42.setPWMFreq(50);
    pwm43.begin();
    pwm43.setPWMFreq(50);
    pwm44.begin();
    pwm44.setPWMFreq(50);
    pwm45.begin();
    pwm45.setPWMFreq(50);
    pwm46.begin();
    pwm46.setPWMFreq(50);
    pwm47.begin();
    pwm47.setPWMFreq(50);
}

//=========================================================================================

void SetPCA9685(byte addr, byte angl)  //отправляем очередной шаг
{
    switch(addr >> 4)  //определяем адрес драйвера РСА
    {
        case 0:  pwm40.setPWM(addr & 15, 0, SERVOMIN + angl);  break;  //полетела команда
        case 1:  pwm41.setPWM(addr & 15, 0, SERVOMIN + angl);  break;  
        case 2:  pwm42.setPWM(addr & 15, 0, SERVOMIN + angl);  break;  
        case 3:  pwm43.setPWM(addr & 15, 0, SERVOMIN + angl);  break;  
        case 4:  pwm44.setPWM(addr & 15, 0, SERVOMIN + angl);  break;  
        case 5:  pwm45.setPWM(addr & 15, 0, SERVOMIN + angl);  break;  
        case 6:  pwm46.setPWM(addr & 15, 0, SERVOMIN + angl);  break;  
        case 7:  pwm47.setPWM(addr & 15, 0, SERVOMIN + angl);  break;                    
    }
}

//=========================================================================================

void ConfigureDecoder()  //переменные серв
{
    for(byte addr=0; addr<128; addr++)
    {
    //первичная инициализация, после сохранения закомментировать
    /*    angleMin[addr] = 100;  
        angleMax[addr] = 150;               
        srvSpeed[addr] = 5;              
        srvSetup[addr] = B00000000;*/

    //для "чистой" ардуинки закомментировать до первого сохранения
        angleMin[addr] = EEPROM.read(addr);  
        angleMax[addr] = EEPROM.read(128 + addr);               
        srvSpeed[addr] = EEPROM.read(256 + addr);              
        srvSetup[addr] = EEPROM.read(384 + addr);
        
        //вычисляется
        angleNow[addr] = angleMin[addr] / 2 + angleMax[addr] / 2;  
        srvBool[addr] = B00000000;
    }
}

//=========================================================================================

void LcdClear()  //очистка экрана
{ 
    lcd.setCursor(0, 0);
    lcd.print(F("Adr             "));
    lcd.setCursor(0, 1);
    lcd.print(F("                "));
}

//=========================================================================================

void EncoderButton()  //обработка прерывания от кнопки энкодера
{ 
    switch(menuNum)  //навигация по меню
    {
        case 0: {  //переход к выбору адреса
            menuNum = 1;
            inNext = 0;
            encVal = addrOld;  //задаём работу с адресом
            encMin = 0;  //граничные значения
            encMax = 127;
            attachInterrupt(1, EncoderRoll, FALLING);  //включаем прерывание от вращения энкодера
            break;
        }
        case 1: {  //переход к установке минимального угла
            menuNum = 2;
            addrOld = encVal;  //сохраняем результат предыдущего шага настройки
            encVal = angleMin[addrOld];
            encMin = 0;
            encMax = angleMax[addrOld];
            break;
        }
        case 2: {  //переход к установке максимального угла
            menuNum = 3;
            angleMin[addrOld] = encVal;  //сохраняем результат предыдущего шага настройки
            encVal = angleMax[addrOld];
            encMin = angleMin[addrOld];
            encMax = 255;
            break;
        }
        case 3: {  //переход к установке скорости
            menuNum = 4;
            angleMax[addrOld] = encVal;  //сохраняем результат предыдущего шага настройки
            angleNow[addrOld] = angleMin[addrOld] / 2 + angleMax[addrOld] / 2;
            encVal = srvSpeed[addrOld];
            encMin = 1;
            encMax = 255;
            break;
        }
        case 4: {  //переход к установке реверса
            menuNum = 5;
            srvSpeed[addrOld] = encVal;  //сохраняем результат предыдущего шага настройки
            encVal = bitRead(srvSetup[addrOld], 7);
            encMin = 0;
            encMax = 1;
            break;
        }
        case 5: {  //переход к выбору
            menuNum = 6;
            bitWrite(srvSetup[addrOld], 7, encVal);  //сохраняем результат предыдущего шага настройки
            encVal = 1;
            encMin = 0;
            encMax = 3;
            break;
        }
        case 6: {  //выбор
            menuNum = 7 + encVal;
            break;
        }
    }
}

//=========================================================================================

void EncoderRoll()  //обработка прерывания от енкодера
{ 
    byte _pin = PIND;  //читаем порт
    if( (_pin >> 4) & 1 ) encVal++; else encVal--;  //определяем направление поворота
    if( encVal > encMax ) encVal = encMin;  //граничные значения
    if( encVal < encMin ) encVal = encMax;
}

//=========================================================================================

void PrnAdrLCD(byte addr)  //вывод адреса в нужную позицию экрана
{
    byte port = addr & 0b00000011;
    addr = addr >> 2 + addrStart;
    lcd.setCursor(4, 0);  //установка позиции вывода
    if( addr < 10 ) lcd.print(F("  ")); else if( addr < 100 ) lcd.print(F(" "));  //добавление пробелов
    lcd.print(addr);  //вывод адреса
    lcd.print(F(":"));
    lcd.print(port);
}

//=========================================================================================

void PrnNumLCD(byte addr, byte poscol, byte posrow)  //вывод числа в нужную позицию экрана
{
    lcd.setCursor(poscol, posrow);  //установка позиции вывода
    if( addr < 10 ) lcd.print(F("  ")); else if( addr < 100 ) lcd.print(F(" "));  //добавление пробелов
    lcd.print(addr);  //вывод числа
}

//=========================================================================================

void setup() 
{ 
    ConfigurePCA9685();
    ConfigureDecoder();
      
    int ar = analogRead(17);
    if( ar < 600 )  //если на входе земля
    {
        inLCD = 1;  //ставим флаг
        lcd.init();  //инициализация дисплея                   
        lcd.createChar(0, newChar0);  //загружаем спец.символы
        lcd.createChar(1, newChar1);
        lcd.setBacklight(true);
        LcdClear();    
//        lcd.setCursor(4, 1);
//        lcd.print(ar);
        pinMode(2, INPUT);  //вход кнопки энкодера
        pinMode(3, INPUT);  //вход 1 ручки энкодера
        pinMode(4, INPUT);  //вход 2 ручки энкодера
        if( ar < 50 )  //если кнопка нажата - инициализация при старте
        {
            lcd.setCursor(4, 0);
            lcd.print(F("Initialising"));
            for(byte addr=0; addr<128; addr++)
            {
                SetPCA9685(addr, angleNow[addr]);  //выставляем в среднее положение             
            }
            delay(3000);
            LcdClear();
        }        
        attachInterrupt(0, EncoderButton, FALLING);  //включаем прерывание от кнопки энкодера
    }
    
    Serial.begin(115200);
    pinMode(12, OUTPUT);
    digitalWrite(12, 0);
    pinMode(13, OUTPUT);
    digitalWrite(13, 0);
}

//=========================================================================================

void ticTimer()  //определение серв "в работе" и отработка очередного шага
{
    for(byte addr=0; addr<128; addr++)  //перебираем адреса
    {
        if( bitRead(srvBool[addr], 1) )  //если флаг "в работе"
        {
            digitalWrite(12, 1);  //test
            if( bitRead(srvBool[addr], 2) > bitRead(srvBool[addr], 3) )  //если стрелка в поз.0 а команда в поз.1
            {
                angleNow[addr] = angleNow[addr] + srvSpeed[addr];  //вычисляем шаг для сервы
                if( angleNow[addr] >= angleMax[addr] )  //когда команда отработана
                {
                    angleNow[addr] = angleMax[addr];
                    bitSet(srvBool[addr], 3);  //прописываем новое положение
                    bitClear(srvBool[addr], 1);  //сбрасываем флаг "в работе"
                }
                SetPCA9685(addr, angleNow[addr]);  //отправляем очередной шаг  
            }
            if( bitRead(srvBool[addr], 3) > bitRead(srvBool[addr], 2) )  //если стрелка в поз.1 а команда в поз.0
            {
                angleNow[addr] = angleNow[addr] - srvSpeed[addr];  //вычисляем шаг для сервы
                if( angleNow[addr] <= angleMin[addr] )  //когда команда отработана
                {
                    angleNow[addr] = angleMin[addr];
                    bitClear(srvBool[addr], 3);  //прописываем новое положение
                    bitClear(srvBool[addr], 1);  //сбрасываем флаг "в работе"
                }
                SetPCA9685(addr, angleNow[addr]);  //отправляем очередной шаг  
            }
            digitalWrite(12, 0);
        }
    }
}

//=========================================================================================

void loop()
{
    if ( Serial.available() > 0 && !menuNum )  //если получена команда и не в режиме настройки
    {
        digitalWrite(13, 1);  //индикация работы
        byte ser = Serial.read();  //читаем пришедшую команду
        byte addr = ser >> 1;  //получаем порядковый адрес
        bool direct = ser & 1;  //получаем команду направления
        if( bitRead(srvSetup[addr], 7) )  //если для сервы стоит реверсирование направления
        {
            direct = !direct;  //меняем команду
        }
        if( bitRead(srvBool[addr], 2) != direct )  //если нужный декодер получает новое положение
        {
            bitSet(srvBool[addr], 1);  //выставляем флаг "в работе"
            bitWrite(srvBool[addr], 2, direct);  //прописываем команду (новое положение сервы)
            bitWrite(srvBool[addr], 3, !direct);  //меняем статус (старое положение сервы)
        }
        if( inLCD )
        {
            PrnAdrLCD(addr);  //выводим адрес
            lcd.print(F(" "));
            if( ser & 1 ) lcd.write(1); else lcd.write(0);  //выводим направление стрелки
        }
        digitalWrite(13, 0);  //индикация работы - моргание
    }

    if( (millis() - onMilli) >= 20 && !menuNum )  //timer 20ms - 50Гц
    {
        onMilli = millis();
        ticTimer();  //запускаем очередной шаг
    }

    if( (millis() - onMilli) >= 250 && menuNum )  //  режим установки драйверов
    {
        onMilli = millis();
        switch(menuNum)  //  работа в зависимости от пункта меню установки
        {
            case 1: {  //выбор адреса
                PrnAdrLCD(encVal);  //адрес
                lcd.print(F("    adr"));
                PrnNumLCD(angleMin[encVal], 0, 1);  //мин.угол
                lcd.print(F("m "));
                PrnNumLCD(angleMax[encVal], 5, 1);  //макс.угол
                lcd.print(F("M "));
                PrnNumLCD(srvSpeed[encVal], 10, 1);  //скор.перекл.
                lcd.print(F("s "));
                if( bitRead(srvSetup[encVal], 7) ) lcd.write(1); else lcd.write(0);  //реверс
                break;
            }
            case 2: {  //изменение минимального угла
                lcd.setCursor(13, 0);
                lcd.print(F("min"));
                PrnNumLCD(encVal, 0, 1);
                angleMin[addrOld] = encVal;
                SetPCA9685(addrOld, encVal);  //отправляем команду на драйвер
                break;
            }
            case 3: {  //изменение максимального угла
                lcd.setCursor(13, 0);
                lcd.print(F("Max"));
                PrnNumLCD(encVal, 5, 1);
                angleMax[addrOld] = encVal;
                SetPCA9685(addrOld, encVal);
                break;
            }
            case 4: {  //изменение скорости
                lcd.setCursor(13, 0);
                lcd.print(F("spd"));
                PrnNumLCD(encVal, 10, 1);
                srvSpeed[addrOld] = encVal;
                int ar = analogRead(17);  //нажата ли кнопка?
                if( ar > 50 ) break;  //если не было изменений, пропускаем  srvSpdOld == srvSpeed[addrOld]  || 
                detachInterrupt(0);
                detachInterrupt(1);
                if( bitRead(srvBool[addrOld], 3) )  //если была позиция 1
                {
                    bitClear(srvBool[addrOld], 2);  //даём команду 0
                    while( bitRead(srvBool[addrOld], 3) > bitRead(srvBool[addrOld], 2) )  //пока не достигли
                    {
                        angleNow[addrOld] = angleNow[addrOld] - srvSpeed[addrOld];  //вычисляем шаг для сервы
                        if( angleNow[addrOld] < angleMin[addrOld] )  //если достигли
                        {
                            angleNow[addrOld] = angleMin[addrOld];
                            bitClear(srvBool[addrOld], 3);
                        }
                        SetPCA9685(addrOld, angleNow[addrOld]);  //отправляем на драйвер
                        delay(20);
                    }
                } else  //если была позиция 0
                {
                    bitSet(srvBool[addrOld], 2);  //даём команду 1
                    while( bitRead(srvBool[addrOld], 2) > bitRead(srvBool[addrOld], 3) )  //пока не достигли
                    {
                        angleNow[addrOld] = angleNow[addrOld] + srvSpeed[addrOld];  //вычисляем шаг для сервы
                        if( angleNow[addrOld] > angleMax[addrOld] )  //если достигли
                        {
                            angleNow[addrOld] = angleMax[addrOld];
                            bitSet(srvBool[addrOld], 3);
                        }
                        SetPCA9685(addrOld, angleNow[addrOld]);  //отправляем на драйвер
                        delay(20);
                    }
                                      
                }
                srvSpdOld = srvSpeed[addrOld];  //запоминаем последнее значение
                attachInterrupt(1, EncoderRoll, FALLING);
                attachInterrupt(0, EncoderButton, FALLING);
                break;
            }
            case 5: {  //изменение реверса
                lcd.setCursor(13, 0);
                lcd.print(F("inv"));
                lcd.setCursor(15, 1);
                bitWrite(srvSetup[addrOld], 7, encVal);
                lcd.write(encVal);
                break;
            }
            case 6: {  //выбор дальнейших действий
                lcd.setCursor(9, 0);
                switch(encVal)
                {
                    case 0: {lcd.print(F(" 1 MORE")); break;}  //дополнительные настройки
                    case 1: {lcd.print(F(" 2 NEXT")); break;}  //следующий адрес
                    case 2: {lcd.print(F(" 3 EXIT")); break;}  //выход из настроек
                    case 3: {lcd.print(F(" 4 SAVE")); break;}  //обновить EEPROM
                }
                break;
            }
            case 7: {  //MORE
                detachInterrupt(1);
                LcdClear();
                menuNum = 0;
                break;
            }
            case 8: {  //NEXT
                detachInterrupt(1);
                LcdClear();
                inNext = 1;
                menuNum = 0;
                if( addrOld < 127 ) addrOld++;  //следующий адрес
                break;
            }
            case 9: {  //EXIT
                detachInterrupt(1);
                LcdClear();
                menuNum = 0;
                break;
            }
            case 10: {  //SAVE
                detachInterrupt(1);
                detachInterrupt(0);
                lcd.setCursor(0, 0);
                lcd.print(F("EEPROM in update"));
                lcd.setCursor(0, 1);
                lcd.print(F("Min             "));
                for(byte _adr=0; _adr<128; _adr++)  //angleMin
                {
                    EEPROM.update(_adr, angleMin[_adr]);
                }
                lcd.setCursor(3, 1);
                lcd.print(F("Max"));
                for(byte _adr=0; _adr<128; _adr++)  //angleMax
                {
                    EEPROM.update(128 + _adr, angleMax[_adr]);
                }
                lcd.print(F("Spd"));
                for(byte _adr=0; _adr<128; _adr++)  //srvSpeed
                {
                    EEPROM.update(256 + _adr, srvSpeed[_adr]);
                }
                lcd.print(F("Set"));
                for(byte _adr=0; _adr<128; _adr++)  //srvSetup
                {
                    EEPROM.update(384 + _adr, srvSetup[_adr]);
                }
                lcd.print(F("End"));
                delay(1000);  //прочие настройки
                lcd.setCursor(0, 0);
                lcd.print(F("EEPROM is update"));
                lcd.setCursor(0, 1);
                lcd.print(F("now succesfully "));
                delay(3000);
                LcdClear();
                menuNum = 0;
                attachInterrupt(0, EncoderButton, FALLING);
                break;
            }
        }
    }

    if( inNext ) EncoderButton();  //продолжаем настраивать
    digitalWrite(13, menuNum);  //индикация настройки - постоянно
}

